#include "LIS3DH.h"
#include "mbed.h"

//#define FAKE_ACC

#ifdef FAKE_ACC
void LIS3DH_init(void){
  
}

uint8_t LIS3DH_read(uint8_t address){
    return 0;
}

void LIS3DH_write(uint8_t data, uint8_t address){

}

uint8_t LIS3DH2_read(uint8_t address){

    return 0;
}

void LIS3DH2_write(uint8_t data, uint8_t address){
    
}

void LIS3DH_readAll(int16_t xyz[]){
    xyz[0] = 200;
    xyz[1] = 200;
}
#else
SPI spi(P0_24, P0_23, P0_25); // mosi, miso, sclk
DigitalOut cs(P0_28);
DigitalOut cs2(P0_12);


void LIS3DH_init(void){
    cs = 1;
    cs2 = 1;
 
    // Setup the spi for 8 bit data, high steady state clock,
    // second edge capture, with a 4MHz clock rate
    spi.format(8,3);
    spi.frequency(4000000);
    
    LIS3DH_write(LIS3DH_CTRL_REG1_DATARATE_5000HZ | LIS3DH_CTRL_REG1_XYZEN, LIS3DH_REGISTER_CTRL_REG1);
    
        
    uint8_t who = LIS3DH_read(LIS3DH_REGISTER_WHO_AM_I);
   // pc.printf("WHOAMI register = %u\r\n", who);
    //LIS3DH_write(LIS3DH_CTRL_REG4_BLOCKDATAUPDATE | LIS3DH_CTRL_REG4_SCALE_8G | LIS3DH_CTRL_REG4_HIGH_RES, LIS3DH_REGISTER_CTRL_REG4);
    LIS3DH_write(LIS3DH_CTRL_REG4_SCALE_8G | LIS3DH_CTRL_REG4_HIGH_RES, LIS3DH_REGISTER_CTRL_REG4);
    
    /*LIS3DH2_write(LIS3DH_CTRL_REG1_DATARATE_5000HZ | LIS3DH_CTRL_REG1_XYZEN, LIS3DH_REGISTER_CTRL_REG1);
    who = LIS3DH2_read(LIS3DH_REGISTER_WHO_AM_I);
    //pc.printf("WHOAMI register = %u\r\n", who);
    LIS3DH2_write(LIS3DH_CTRL_REG4_SCALE_8G | LIS3DH_CTRL_REG4_HIGH_RES, LIS3DH_REGISTER_CTRL_REG4);
*/
    //UART.printf("WHOAMI register = %u\r\n", who);
}

uint8_t LIS3DH_read(uint8_t address){
    cs = 0;
    spi.write(address|READ);
    uint8_t data = spi.write(READ);
    cs = 1;
    return data;
}

void LIS3DH_write(uint8_t data, uint8_t address){
    cs = 0;
    spi.write(address|WRITE);
    spi.write(data);
    cs = 1;
}

uint8_t LIS3DH2_read(uint8_t address){
    cs2 = 0;
    spi.write(address|READ);
    uint8_t data = spi.write(READ);
    cs2 = 1;
    return data;
}

void LIS3DH2_write(uint8_t data, uint8_t address){
    cs2 = 0;
    spi.write(address|WRITE);
    spi.write(data);
    cs2 = 1;
}

void LIS3DH_readAll(int16_t xyz[]){
    //char reg;
    //char xyz8[3];
    //static int count = 0;
    
    int16_t value;
    uint8_t *valueL = (uint8_t *)(&value);
    uint8_t *valueH = ((uint8_t *)(&value)+1);
    
    *valueL = LIS3DH_read(LIS3DH_REGISTER_OUT_X_L);
    *valueH = LIS3DH_read(LIS3DH_REGISTER_OUT_X_H);
    xyz[0] = value + 960;

    /* don't need z values
    *valueL = LIS3DH_read(LIS3DH_REGISTER_OUT_Y_L);
    *valueH = LIS3DH_read(LIS3DH_REGISTER_OUT_Y_H);
    xyz[1] = value + 960;
    */
    *valueL = LIS3DH_read(LIS3DH_REGISTER_OUT_Z_L);
    *valueH = LIS3DH_read(LIS3DH_REGISTER_OUT_Z_H);
    xyz[2] = value + 2048;
}
#endif